#  SPDX-FileCopyrightText: © 2022 Josef Hahn
#  SPDX-License-Identifier: AGPL-3.0-only
import asyncio

import klovve


class Model(klovve.Model):

    txt = klovve.Property(default=lambda: "")

    def __init__(self, **kwargs):
        super().__init__(**kwargs)

        def fries():
            self.txt = "goof"

        asyncio.get_running_loop().call_later(5, fries)


class View(klovve.ComposedView):

    @klovve.ComputedProperty
    def df(self):
        pieces, props = self.make_view()
        if self.model.txt:
            return pieces.label(text=props.txt)

    def compose(self):
        pieces, props = self.make_view()
        return pieces.window(
            body=pieces.vertical_box(
                items=[
                    pieces.placeholder(item=props.df),
                ]
            ),
            title="boom",
        )
